#pragma once

#include <string>

class MarkdownElement
{
public:
    enum class Type
    {
        HEADING,
        PARAGRAPH,
        TEXT_SPAN,
        INLINE_QUOTE,
        MULTILINE_QUOTE,
        CUSTOM_INLINE,
        CUSTOM_MULTILINE,
        LINK,
        IMAGE,
        BULLET_ITEM,
        BULLET_LIST
    };

    virtual ~MarkdownElement() = default;

    void appendTextContent(const std::string& content);

    void addLine(const std::string& line);

    const std::string& getTextContent() const;

    virtual Type getType() const = 0;

    virtual void doFieldSubstitution(Type elementType, const std::string& searchPhrase, const std::string& replacementPhrase)
    {

    }
private:
    std::string mTextContent;
};

class MarkdownInlineElement : public MarkdownElement
{
public:
    virtual ~MarkdownInlineElement() = default;
};

class MarkdownMultilineElement : public MarkdownElement
{
public:
    virtual ~MarkdownMultilineElement() = default;
};
